import { createCustomMethodDecorator, JoinPoint } from '@midwayjs/core';
import { REQUEST_OBJ_CTX_KEY } from '@midwayjs/core';
import { ActivitysService } from '../service/activitys.service';
export const ADDACTTIME_KEY = 'decorator:addActTime';
export function AddActTime(): MethodDecorator {
  return createCustomMethodDecorator(ADDACTTIME_KEY, {});
}
export function AddActTimeInit(options) {
  return {
    around: async (joinPoint: JoinPoint) => {
      const instance = joinPoint.target;
      const ctx = instance[REQUEST_OBJ_CTX_KEY];
      const service = await ctx.requestContext.getAsync(ActivitysService);
      const id = await service.addActTime();
      if (id) {
        const arg = joinPoint.args[0];
        arg.act_time = id;
      }
      await joinPoint.proceed(...joinPoint.args);
    },
  };
}
