import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'achieve' },
})
export class Achieve extends BaseModel {
  @prop({ required: false, index: true, zh: '实验室id' })
  lab_id: string;
  @prop({ required: false, index: false, zh: '类型', remark: '字典;achieve_type' })
  type: string;
  @prop({ required: false, index: false, zh: '合作名称' })
  name: string;
  @prop({ required: false, index: false, zh: '合作单位' })
  unit: string;
  @prop({ required: false, index: true, zh: '合作单位类型', remark: '字典:achieve_unitType' })
  unit_type: string;
  @prop({ required: false, index: false, zh: '金额(万元)' })
  money: string;
  @prop({ required: false, index: false, zh: '合作方式', remark: '字典:achieve_way' })
  way: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '是否公开' })
  is_show: string;
  @prop({ required: false, index: false, zh: '完成时间' })
  time: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
