import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'award' },
})
export class Award extends BaseModel {
  @prop({ required: false, index: true, zh: '类别', remark: '字典:jiang_type' })
  type: string;
  @prop({ required: false, index: true, zh: '成果编号' })
  resulnumber: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({ required: false, index: false, zh: '获奖等级' })
  level: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: true, zh: '获奖人', ref: 'person' })
  user_id: Array<any>;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: false, zh: '成果简介' })
  content: string;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show' })
  is_show: string;
  @prop({ required: false, index: false, zh: '获奖时间' })
  time: string;
  @prop({ required: false, index: false, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
