import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'equipment' },
})
export class Equipment extends BaseModel {
  @prop({ required: false, index: false, zh: '设备数量' })
  equipment_numb: string;
  @prop({ required: false, index: false, zh: '是否加入大型仪器服务共享平台' })
  instruments_numb: string;
  @prop({ required: false, index: false, zh: '设备价值(万元)' })
  equipment_money: string;
  @prop({ required: false, index: false, zh: '仪器研究工作计时(小时)' })
  research_hour: string;
  @prop({ required: false, index: false, zh: '仪器服务工作计时(小时)' })
  services_hour: string;
  @prop({ required: false, index: false, zh: '机时率' })
  rate: string;
  @prop({ required: false, index: true, zh: '设备名称' })
  name: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: 'info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
