import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'fixInput' },
})
export class FixInput extends BaseModel {
  @prop({ required: false, index: false, zh: '年度' })
  year: string;
  @prop({ required: false, index: false, zh: '国家级经费投入' })
  country_money: string;
  @prop({ required: false, index: false, zh: '省级经费投入' })
  province_money: string;
  @prop({ required: false, index: false, zh: '横向经费投入' })
  transverse_money: string;
  @prop({ required: false, index: false, zh: '其他投入' })
  other_money: string;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show', default: '1' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
