import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'otherAward' },
})
export class OtherAward extends BaseModel {
  @prop({ required: false, index: true, zh: '成果类型', remark: '字典:cheng_resulttype' })
  type: string;
  @prop({ required: false, index: true, zh: '成果编号' })
  num: string;
  @prop({ required: false, index: true, zh: '成果名称' })
  name: string;
  @prop({ required: false, index: true, zh: '完成人', ref: 'person' })
  user_id: Array<any>;
  @prop({ required: false, index: false, zh: '完成单位' })
  company: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: false, zh: '发表时间', exportQuery: 'time' })
  time: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
