import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'paper' },
})
export class Paper extends BaseModel {
  @prop({ required: false, index: true, zh: '论文题目' })
  title: string;
  @prop({ required: false, index: false, zh: '期刊及卷号' })
  number: string;
  @prop({ required: false, index: false, zh: '起止页码' })
  startnum: string;
  @prop({ required: false, index: false, zh: '论文类别', remark: '字典:lun_type' })
  type: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false, zh: '作者', ref: 'person' })
  user_id: Array<any>;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '发表时间', exportQuery: 'time' })
  time: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
