import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'science' },
})
export class Science extends BaseModel {
  @prop({ required: false, index: true, zh: '项目名称' })
  name: string;
  @prop({ required: false, index: false, zh: '起止时间' })
  time: Array<any>;
  @prop({ required: false, index: false, zh: '项目来源' })
  projectsource: string;
  @prop({ required: false, index: false, zh: '项目号' })
  projectlevelone: string;
  @prop({ required: false, index: false, zh: '经费' })
  money: string;
  @prop({ required: false, index: false, zh: '负责人' })
  fzuser: string;
  @prop({ required: false, index: false, zh: '主要参加人' })
  participants: Array<any>;
  @prop({ required: false, index: false, zh: '核心成员所占比例' })
  userproportion: string;
  @prop({ required: false, index: false, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false, zh: '合作单位' })
  cooperativeunit: string;
  @prop({ required: false, index: false, zh: '转化效益（万元）' })
  statemoney: string;
  @prop({ required: false, index: false, zh: '项目来源2' })
  projectsourcetwo: string;
  @prop({ required: false, index: false, zh: '项目总人数' })
  usernum: string;
  @prop({ required: false, index: false, zh: '项目来源文本' })
  laiyuancontent: string;
  @prop({ required: false, index: false, zh: '状态', remark: '字典:keyan_type' })
  state: string;
  @prop({ required: false, index: false, zh: '立项标准部门（单位）' })
  labname: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
