import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'technicalservice' },
})
export class Technicalservice extends BaseModel {
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '活动名称' })
  name: string;
  @prop({ required: false, index: false, zh: '活动类型', remark: 'activity_type' })
  type: string;
  @prop({ required: false, index: false, zh: '活动时间', exportQuery: 'time' })
  time: Array<any>;
  @prop({ required: false, index: false, zh: '充当角色', remark: 'activity_role' })
  role: string;
  @prop({ required: false, index: false, zh: '参与人数' })
  number: number;
  @prop({ required: false, index: false, zh: '宣传报道', remark: 'activity_propaganda' })
  propaganda: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '是否公开', remark: 'info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
