import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'company' },
})
export class Company extends BaseModel {
  @prop({ required: false, index: true, zh: '单位名称' })
  name: string;
  @prop({ required: false, index: false, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: false, zh: '联系人电话' })
  phone: string;
  @prop({ required: false, index: false, zh: '单位类别', remark: '字典:company_type' })
  type: string;
  @prop({ required: false, index: false, zh: '单位性质', remark: '字典:company_nature' })
  nature: string;
  @prop({ required: false, index: false, zh: '隶属', remark: '字典:company_subjection' })
  subjection: string;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
}
