import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'direction' },
})
export class Direction extends BaseModel {
  @prop({ required: false, index: true, zh: '方向名称' })
  name: string;
  @prop({ required: false, index: true }) //方向带头人id
  person_id: string;
  @prop({ required: false, index: true, zh: '方向带头人' })
  person_name: string;
  @prop({ required: false, index: false, zh: '核心成员', ref: 'person' })
  persons: Array<any>;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典:info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
