import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'committee' },
})
export class Committee extends BaseModel {
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '单位' })
  unit: string;
  @prop({ required: false, index: false, zh: '职务职称' })
  zwzc: string;
  @prop({ required: false, index: false, zh: '年龄' })
  age: string;
  @prop({ required: false, index: false, zh: '专业' })
  major: string;
  @prop({ required: false, index: false, zh: '称号' })
  title: string;
  @prop({ required: false, index: false, zh: '任期时间', exportFormat: 'turnArrayTimeToString' })
  term_of: Array<any>;
  @prop({ required: false, index: false, zh: '本实验室职务', exportFormat: 'turnArrayToString' })
  type: Array<any>;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: '字典;info_show', default: '1' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
