import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'doctor' },
})
export class Doctor extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '指导教师' })
  teacher: string;
  @prop({ required: false, index: false, zh: '学位', remark: 'degree' })
  education: string;
  @prop({ required: false, index: false, zh: '状态' })
  state: string;
  @prop({ required: false, index: true, zh: '研究方向' })
  direction: string;
  @prop({ required: false, index: false }) //附件
  file: Array<any>;
  @prop({ required: false, index: false, zh: '完成时间', exportQuery: 'time' })
  time: string;
  @prop({ required: false, index: true, zh: '实验室信息' })
  lab_id: string;
  @prop({ required: false, index: true, zh: '是否公开', remark: 'info_show' })
  is_show: string;
  @prop({ required: false, index: true, zh: '填写时间段', ref: 'Activitys' })
  act_time: string;
}
