import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_achieve {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '合作名称' })
  'name': string = undefined;
  @ApiProperty({ description: '合作单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '合作单位类型' })
  'unit_type': string = undefined;
  @ApiProperty({ description: '金额(万元)' })
  'money': string = undefined;
  @ApiProperty({ description: '合作方式' })
  'way': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '完成时间' })
  'time': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_achieve extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['lab_id', 'unit_type', 'is_show', 'act_time', 'name', 'unit', 'way', 'type'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '合作单位类型' })
  'unit_type': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '合作名称' })
  'name': string = undefined;
  @ApiProperty({ description: '合作单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '合作方式' })
  'way': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
}

export class QVO_achieve extends FVO_achieve {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_achieve {
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '合作名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '合作单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '合作单位类型' })
  @Rule(RuleType['string']().empty(''))
  'unit_type': string = undefined;
  @ApiProperty({ description: '金额(万元)' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '合作方式' })
  @Rule(RuleType['string']().empty(''))
  'way': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '完成时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_achieve extends FVO_achieve {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_achieve extends CDTO_achieve {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_achieve extends FVO_achieve {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
