import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_award {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '获奖等级' })
  'level': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '获奖人' })
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '成果简介' })
  'content': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '获奖时间' })
  'time': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_award extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['type', 'resulnumber', 'name', 'direction', 'user_id', 'lab_id', 'is_show', 'level'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '获奖人' })
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '获奖等级' })
  'level': string = undefined;
}

export class QVO_award extends FVO_award {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_award {
  @ApiProperty({ description: '类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  @Rule(RuleType['string']().empty(''))
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '获奖等级' })
  @Rule(RuleType['string']().empty(''))
  'level': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '获奖人' })
  @Rule(RuleType['array']().empty(''))
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '成果简介' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '获奖时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_award extends FVO_award {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_award extends CDTO_award {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_award extends FVO_award {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
