import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_equipment {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '设备数量' })
  'equipment_numb': string = undefined;
  @ApiProperty({ description: '是否加入大型仪器服务共享平台' })
  'instruments_numb': string = undefined;
  @ApiProperty({ description: '设备价值(万元)' })
  'equipment_money': string = undefined;
  @ApiProperty({ description: '仪器研究工作计时(小时)' })
  'research_hour': string = undefined;
  @ApiProperty({ description: '仪器服务工作计时(小时)' })
  'services_hour': string = undefined;
  @ApiProperty({ description: '机时率' })
  'rate': string = undefined;
  @ApiProperty({ description: '设备名称' })
  'name': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_equipment extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'is_show', 'act_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '设备名称' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QVO_equipment extends FVO_equipment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_equipment {
  @ApiProperty({ description: '设备数量' })
  @Rule(RuleType['string']().empty(''))
  'equipment_numb': string = undefined;
  @ApiProperty({ description: '是否加入大型仪器服务共享平台' })
  @Rule(RuleType['string']().empty(''))
  'instruments_numb': string = undefined;
  @ApiProperty({ description: '设备价值(万元)' })
  @Rule(RuleType['string']().empty(''))
  'equipment_money': string = undefined;
  @ApiProperty({ description: '仪器研究工作计时(小时)' })
  @Rule(RuleType['string']().empty(''))
  'research_hour': string = undefined;
  @ApiProperty({ description: '仪器服务工作计时(小时)' })
  @Rule(RuleType['string']().empty(''))
  'services_hour': string = undefined;
  @ApiProperty({ description: '机时率' })
  @Rule(RuleType['string']().empty(''))
  'rate': string = undefined;
  @ApiProperty({ description: '设备名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_equipment extends FVO_equipment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_equipment extends CDTO_equipment {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_equipment extends FVO_equipment {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
