import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_fixInput {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '国家级经费投入' })
  'country_money': string = undefined;
  @ApiProperty({ description: '省级经费投入' })
  'province_money': string = undefined;
  @ApiProperty({ description: '横向经费投入' })
  'transverse_money': string = undefined;
  @ApiProperty({ description: '其他投入' })
  'other_money': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_fixInput extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['lab_id', 'is_show', 'act_time', 'year', 'country_money', 'province_money', 'transverse_money', 'other_money'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '国家级经费投入' })
  'country_money': string = undefined;
  @ApiProperty({ description: '省级经费投入' })
  'province_money': string = undefined;
  @ApiProperty({ description: '横向经费投入' })
  'transverse_money': string = undefined;
  @ApiProperty({ description: '其他投入' })
  'other_money': string = undefined;
}

export class QVO_fixInput extends FVO_fixInput {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_fixInput {
  @ApiProperty({ description: '年度' })
  @Rule(RuleType['string']().empty(''))
  'year': string = undefined;
  @ApiProperty({ description: '国家级经费投入' })
  @Rule(RuleType['string']().empty(''))
  'country_money': string = undefined;
  @ApiProperty({ description: '省级经费投入' })
  @Rule(RuleType['string']().empty(''))
  'province_money': string = undefined;
  @ApiProperty({ description: '横向经费投入' })
  @Rule(RuleType['string']().empty(''))
  'transverse_money': string = undefined;
  @ApiProperty({ description: '其他投入' })
  @Rule(RuleType['string']().empty(''))
  'other_money': string = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_fixInput extends FVO_fixInput {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_fixInput extends CDTO_fixInput {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_fixInput extends FVO_fixInput {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
