import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_science {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '起止时间' })
  'time': Array<any> = undefined;
  @ApiProperty({ description: '项目来源' })
  'projectsource': string = undefined;
  @ApiProperty({ description: '项目号' })
  'projectlevelone': string = undefined;
  @ApiProperty({ description: '经费' })
  'money': string = undefined;
  @ApiProperty({ description: '负责人' })
  'fzuser': string = undefined;
  @ApiProperty({ description: '主要参加人' })
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '核心成员所占比例' })
  'userproportion': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '合作单位' })
  'cooperativeunit': string = undefined;
  @ApiProperty({ description: '转化效益（万元）' })
  'statemoney': string = undefined;
  @ApiProperty({ description: '项目来源2' })
  'projectsourcetwo': string = undefined;
  @ApiProperty({ description: '项目总人数' })
  'usernum': string = undefined;
  @ApiProperty({ description: '项目来源文本' })
  'laiyuancontent': string = undefined;
  @ApiProperty({ description: '状态' })
  'state': string = undefined;
  @ApiProperty({ description: '立项标准部门（单位）' })
  'labname': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_science extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'is_show', 'act_time', 'projectsource', 'direction', 'money', 'cooperativeunit'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '项目来源' })
  'projectsource': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '经费' })
  'money': string = undefined;
  @ApiProperty({ description: '合作单位' })
  'cooperativeunit': string = undefined;
}

export class QVO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_science {
  @ApiProperty({ description: '项目名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '起止时间' })
  @Rule(RuleType['array']().empty(''))
  'time': Array<any> = undefined;
  @ApiProperty({ description: '项目来源' })
  @Rule(RuleType['string']().empty(''))
  'projectsource': string = undefined;
  @ApiProperty({ description: '项目号' })
  @Rule(RuleType['string']().empty(''))
  'projectlevelone': string = undefined;
  @ApiProperty({ description: '经费' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '负责人' })
  @Rule(RuleType['string']().empty(''))
  'fzuser': string = undefined;
  @ApiProperty({ description: '主要参加人' })
  @Rule(RuleType['array']().empty(''))
  'participants': Array<any> = undefined;
  @ApiProperty({ description: '核心成员所占比例' })
  @Rule(RuleType['string']().empty(''))
  'userproportion': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '合作单位' })
  @Rule(RuleType['string']().empty(''))
  'cooperativeunit': string = undefined;
  @ApiProperty({ description: '转化效益（万元）' })
  @Rule(RuleType['string']().empty(''))
  'statemoney': string = undefined;
  @ApiProperty({ description: '项目来源2' })
  @Rule(RuleType['string']().empty(''))
  'projectsourcetwo': string = undefined;
  @ApiProperty({ description: '项目总人数' })
  @Rule(RuleType['string']().empty(''))
  'usernum': string = undefined;
  @ApiProperty({ description: '项目来源文本' })
  @Rule(RuleType['string']().empty(''))
  'laiyuancontent': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'state': string = undefined;
  @ApiProperty({ description: '立项标准部门（单位）' })
  @Rule(RuleType['string']().empty(''))
  'labname': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_science extends CDTO_science {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_science extends FVO_science {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
