import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_technicalservice {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '活动类型' })
  'type': string = undefined;
  @ApiProperty({ description: '活动时间' })
  'time': Array<any> = undefined;
  @ApiProperty({ description: '充当角色' })
  'role': string = undefined;
  @ApiProperty({ description: '参与人数' })
  'number': number = undefined;
  @ApiProperty({ description: '宣传报道' })
  'propaganda': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_technicalservice extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['lab_id', 'name', 'is_show', 'act_time', 'type', 'role', 'propaganda'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '活动类型' })
  'type': string = undefined;
  @ApiProperty({ description: '充当角色' })
  'role': string = undefined;
  @ApiProperty({ description: '宣传报道' })
  'propaganda': string = undefined;
}

export class QVO_technicalservice extends FVO_technicalservice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_technicalservice {
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '活动名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '活动类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '活动时间' })
  @Rule(RuleType['array']().empty(''))
  'time': Array<any> = undefined;
  @ApiProperty({ description: '充当角色' })
  @Rule(RuleType['string']().empty(''))
  'role': string = undefined;
  @ApiProperty({ description: '参与人数' })
  @Rule(RuleType['number']().empty(''))
  'number': number = undefined;
  @ApiProperty({ description: '宣传报道' })
  @Rule(RuleType['string']().empty(''))
  'propaganda': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_technicalservice extends FVO_technicalservice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_technicalservice extends CDTO_technicalservice {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_technicalservice extends FVO_technicalservice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
