import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_basic {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '实验室类别' })
  'type': string = undefined;
  @ApiProperty({ description: '实验室名称' })
  'name': string = undefined;
  @ApiProperty({ description: '英文名称' })
  'english_name': string = undefined;
  @ApiProperty({ description: '所属学科' })
  'subject': string = undefined;
  @ApiProperty({ description: '所属专业' })
  'major': string = undefined;
  @ApiProperty({ description: '实验室面积' })
  'lab_acreage': string = undefined;
  @ApiProperty({ description: '批建时间' })
  'build_time': string = undefined;
  @ApiProperty({ description: '实验室地址' })
  'lab_address': string = undefined;
  @ApiProperty({ description: '依托单位id' })
  'unit': string = undefined;
  @ApiProperty({ description: '实验室定位' })
  'position': string = undefined;
  @ApiProperty({ description: '实验室建设方案' })
  'plan': Array<any> = undefined;
  @ApiProperty({ description: '实验室主任' })
  'chief_name': string = undefined;
  @ApiProperty({ description: '实验室联系人' })
  'lab_person': string = undefined;
  @ApiProperty({ description: '实验室联系人电话' })
  'lab_phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'lab_email': string = undefined;
  @ApiProperty({ description: '申报单位' })
  'declare_unit': object = undefined;
  @ApiProperty({ description: '平台负责人' })
  'leading_cadre': object = undefined;
  @ApiProperty({ description: '科研助理' })
  'assistant': object = undefined;
  @ApiProperty({ description: '财务助理是否与科研助理同一人' })
  'is_alike': boolean = undefined;
  @ApiProperty({ description: '财务助理' })
  'finance': object = undefined;
  @ApiProperty({ description: '所属吉林省重点实验室' })
  'ss_laboratory': string = undefined;
  @ApiProperty({ description: '整合基础' })
  'zh_basis': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '地区' })
  'region': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '任职记录' })
  'chief_logs': Array<any> = undefined;
}

export class QDTO_basic extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['type', 'name', 'status', 'unit', 'chief_name', 'lab_person'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '实验室类别' })
  'type': string = undefined;
  @ApiProperty({ description: '实验室名称' })
  'name': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '依托单位id' })
  'unit': string = undefined;
  @ApiProperty({ description: '实验室主任' })
  'chief_name': string = undefined;
  @ApiProperty({ description: '实验室联系人' })
  'lab_person': string = undefined;
}

export class QVO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_basic {
  @ApiProperty({ description: '实验室类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '实验室名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '英文名称' })
  @Rule(RuleType['string']().empty(''))
  'english_name': string = undefined;
  @ApiProperty({ description: '所属学科' })
  @Rule(RuleType['string']().empty(''))
  'subject': string = undefined;
  @ApiProperty({ description: '所属专业' })
  @Rule(RuleType['string']().empty(''))
  'major': string = undefined;
  @ApiProperty({ description: '实验室面积' })
  @Rule(RuleType['string']().empty(''))
  'lab_acreage': string = undefined;
  @ApiProperty({ description: '批建时间' })
  @Rule(RuleType['string']().empty(''))
  'build_time': string = undefined;
  @ApiProperty({ description: '实验室地址' })
  @Rule(RuleType['string']().empty(''))
  'lab_address': string = undefined;
  @ApiProperty({ description: '依托单位id' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '实验室定位' })
  @Rule(RuleType['string']().empty(''))
  'position': string = undefined;
  @ApiProperty({ description: '实验室建设方案' })
  @Rule(RuleType['array']().empty(''))
  'plan': Array<any> = undefined;
  @ApiProperty({ description: '实验室主任' })
  @Rule(RuleType['string']().empty(''))
  'chief_name': string = undefined;
  @ApiProperty({ description: '实验室联系人' })
  @Rule(RuleType['string']().empty(''))
  'lab_person': string = undefined;
  @ApiProperty({ description: '实验室联系人电话' })
  @Rule(RuleType['string']().empty(''))
  'lab_phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'lab_email': string = undefined;
  @ApiProperty({ description: '申报单位' })
  @Rule(RuleType['object']().empty(''))
  'declare_unit': object = undefined;
  @ApiProperty({ description: '平台负责人' })
  @Rule(RuleType['object']().empty(''))
  'leading_cadre': object = undefined;
  @ApiProperty({ description: '科研助理' })
  @Rule(RuleType['object']().empty(''))
  'assistant': object = undefined;
  @ApiProperty({ description: '财务助理是否与科研助理同一人' })
  @Rule(RuleType['boolean']().empty(''))
  'is_alike': boolean = undefined;
  @ApiProperty({ description: '财务助理' })
  @Rule(RuleType['object']().empty(''))
  'finance': object = undefined;
  @ApiProperty({ description: '所属吉林省重点实验室' })
  @Rule(RuleType['string']().empty(''))
  'ss_laboratory': string = undefined;
  @ApiProperty({ description: '整合基础' })
  @Rule(RuleType['string']().empty(''))
  'zh_basis': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '地区' })
  @Rule(RuleType['string']().empty(''))
  'region': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '任职记录' })
  @Rule(RuleType['array']().empty(''))
  'chief_logs': Array<any> = undefined;
}

export class CVO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_basic extends CDTO_basic {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_basic extends FVO_basic {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
