import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_build {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '平台概述' })
  'summary': string = undefined;
  @ApiProperty({ description: '平台建设重要意义' })
  'purport': string = undefined;
  @ApiProperty({ description: '平台基础情况' })
  'base': string = undefined;
  @ApiProperty({ description: '平台建设情况' })
  'build': string = undefined;
  @ApiProperty({ description: '平台未来3年发展规划及实施计划' })
  'plan': string = undefined;
  @ApiProperty({ description: '实验室信息' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '填写时间' })
  'act_time': string = undefined;
}

export class QDTO_build extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['lab_id', 'act_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '实验室信息' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '填写时间' })
  'act_time': string = undefined;
}

export class QVO_build extends FVO_build {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_build {
  @ApiProperty({ description: '平台概述' })
  @Rule(RuleType['string']().empty(''))
  'summary': string = undefined;
  @ApiProperty({ description: '平台建设重要意义' })
  @Rule(RuleType['string']().empty(''))
  'purport': string = undefined;
  @ApiProperty({ description: '平台基础情况' })
  @Rule(RuleType['string']().empty(''))
  'base': string = undefined;
  @ApiProperty({ description: '平台建设情况' })
  @Rule(RuleType['string']().empty(''))
  'build': string = undefined;
  @ApiProperty({ description: '平台未来3年发展规划及实施计划' })
  @Rule(RuleType['string']().empty(''))
  'plan': string = undefined;
  @ApiProperty({ description: '实验室信息' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '填写时间' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_build extends FVO_build {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_build extends CDTO_build {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_build extends FVO_build {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
