import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_report {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '报告名称' })
  'name': string = undefined;
  @ApiProperty({ description: '提交部门' })
  'department': string = undefined;
  @ApiProperty({ description: '报告性质' })
  'type': string = undefined;
  @ApiProperty({ description: '是否采纳' })
  'isadopt': string = undefined;
  @ApiProperty({ description: '备注' })
  'content': string = undefined;
  @ApiProperty({ description: '反馈信息' })
  'message': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_report extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'is_show', 'act_time', 'department', 'type', 'isadopt'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '报告名称' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '提交部门' })
  'department': string = undefined;
  @ApiProperty({ description: '报告性质' })
  'type': string = undefined;
  @ApiProperty({ description: '是否采纳' })
  'isadopt': string = undefined;
}

export class QVO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_report {
  @ApiProperty({ description: '报告名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '提交部门' })
  @Rule(RuleType['string']().empty(''))
  'department': string = undefined;
  @ApiProperty({ description: '报告性质' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '是否采纳' })
  @Rule(RuleType['string']().empty(''))
  'isadopt': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '反馈信息' })
  @Rule(RuleType['string']().empty(''))
  'message': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_report extends CDTO_report {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_report extends FVO_report {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
