import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_sjactivity {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '组织者' })
  'usernames': string = undefined;
  @ApiProperty({ description: '充当角色' })
  'role': string = undefined;
  @ApiProperty({ description: '人数' })
  'numbers': string = undefined;
  @ApiProperty({ description: '宣传报导' })
  'propaganda': string = undefined;
  @ApiProperty({ description: '作者备注' })
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_sjactivity extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'is_show', 'act_time', 'usernames', 'propaganda'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '活动名称' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '组织者' })
  'usernames': string = undefined;
  @ApiProperty({ description: '宣传报导' })
  'propaganda': string = undefined;
}

export class QVO_sjactivity extends FVO_sjactivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_sjactivity {
  @ApiProperty({ description: '活动名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '组织者' })
  @Rule(RuleType['string']().empty(''))
  'usernames': string = undefined;
  @ApiProperty({ description: '充当角色' })
  @Rule(RuleType['string']().empty(''))
  'role': string = undefined;
  @ApiProperty({ description: '人数' })
  @Rule(RuleType['string']().empty(''))
  'numbers': string = undefined;
  @ApiProperty({ description: '宣传报导' })
  @Rule(RuleType['string']().empty(''))
  'propaganda': string = undefined;
  @ApiProperty({ description: '作者备注' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_sjactivity extends FVO_sjactivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_sjactivity extends CDTO_sjactivity {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_sjactivity extends FVO_sjactivity {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
