import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_company {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '单位名称' })
  'name': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '联系人电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '单位类别' })
  'type': string = undefined;
  @ApiProperty({ description: '单位性质' })
  'nature': string = undefined;
  @ApiProperty({ description: '隶属' })
  'subjection': string = undefined;
  @ApiProperty({ description: '实验室信息' })
  'lab_id': string = undefined;
}

export class QDTO_company extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'type', 'nature', 'subjection'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '单位名称' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室信息' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '单位类别' })
  'type': string = undefined;
  @ApiProperty({ description: '单位性质' })
  'nature': string = undefined;
  @ApiProperty({ description: '隶属' })
  'subjection': string = undefined;
}

export class QVO_company extends FVO_company {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_company {
  @ApiProperty({ description: '单位名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '联系人电话' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '单位类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '单位性质' })
  @Rule(RuleType['string']().empty(''))
  'nature': string = undefined;
  @ApiProperty({ description: '隶属' })
  @Rule(RuleType['string']().empty(''))
  'subjection': string = undefined;
  @ApiProperty({ description: '实验室信息' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
}

export class CVO_company extends FVO_company {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_company extends CDTO_company {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_company extends FVO_company {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
