import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_direction {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '方向名称' })
  'name': string = undefined;
  @ApiProperty({ description: '方向带头人id' })
  'person_id': string = undefined;
  @ApiProperty({ description: '方向带头人' })
  'person_name': string = undefined;
  @ApiProperty({ description: '核心成员' })
  'persons': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_direction extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'person_id', 'person_name', 'lab_id', 'is_show', 'act_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '方向名称' })
  'name': string = undefined;
  @ApiProperty({ description: '方向带头人id' })
  'person_id': string = undefined;
  @ApiProperty({ description: '方向带头人' })
  'person_name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QVO_direction extends FVO_direction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_direction {
  @ApiProperty({ description: '方向名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '方向带头人id' })
  @Rule(RuleType['string']().empty(''))
  'person_id': string = undefined;
  @ApiProperty({ description: '方向带头人' })
  @Rule(RuleType['string']().empty(''))
  'person_name': string = undefined;
  @ApiProperty({ description: '核心成员' })
  @Rule(RuleType['array']().empty(''))
  'persons': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_direction extends FVO_direction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_direction extends CDTO_direction {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_direction extends FVO_direction {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
