import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_committee {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '专业' })
  'major': string = undefined;
  @ApiProperty({ description: '称号' })
  'title': string = undefined;
  @ApiProperty({ description: '任期时间' })
  'term_of': Array<any> = undefined;
  @ApiProperty({ description: '本实验室职务' })
  'type': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_committee extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'lab_id', 'is_show', 'act_time', 'unit', 'zwzc', 'age', 'title'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '年龄' })
  'age': string = undefined;
  @ApiProperty({ description: '称号' })
  'title': string = undefined;
}

export class QVO_committee extends FVO_committee {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_committee {
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '单位' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  @Rule(RuleType['string']().empty(''))
  'zwzc': string = undefined;
  @ApiProperty({ description: '年龄' })
  @Rule(RuleType['string']().empty(''))
  'age': string = undefined;
  @ApiProperty({ description: '专业' })
  @Rule(RuleType['string']().empty(''))
  'major': string = undefined;
  @ApiProperty({ description: '称号' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '任期时间' })
  @Rule(RuleType['array']().empty(''))
  'term_of': Array<any> = undefined;
  @ApiProperty({ description: '本实验室职务' })
  @Rule(RuleType['array']().empty(''))
  'type': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_committee extends FVO_committee {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_committee extends CDTO_committee {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_committee extends FVO_committee {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
