import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_flowpersonnel {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '工作单位及部门' })
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '学历' })
  'educationale': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  'now_work': string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_flowpersonnel extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['name', 'type', 'lab_id', 'is_show', 'act_time', 'unit', 'zwzc', 'card', 'educationale', 'now_work'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
  @ApiProperty({ description: '工作单位及部门' })
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '学历' })
  'educationale': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  'now_work': string = undefined;
}

export class QVO_flowpersonnel extends FVO_flowpersonnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_flowpersonnel {
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '工作单位及部门' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '职务职称' })
  @Rule(RuleType['string']().empty(''))
  'zwzc': string = undefined;
  @ApiProperty({ description: '身份证号' })
  @Rule(RuleType['string']().empty(''))
  'card': string = undefined;
  @ApiProperty({ description: '学历' })
  @Rule(RuleType['string']().empty(''))
  'educationale': string = undefined;
  @ApiProperty({ description: '现从事专业' })
  @Rule(RuleType['string']().empty(''))
  'now_work': string = undefined;
  @ApiProperty({ description: '类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_flowpersonnel extends FVO_flowpersonnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_flowpersonnel extends CDTO_flowpersonnel {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_flowpersonnel extends FVO_flowpersonnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
