import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_policyfile {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '文件标题' })
  'title': string = undefined;
  @ApiProperty({ description: '文件' })
  'file': Array<any> = undefined;
}

export class QDTO_policyfile extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['title'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '文件标题' })
  'title': string = undefined;
}

export class QVO_policyfile extends FVO_policyfile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_policyfile {
  @ApiProperty({ description: '文件标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '文件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_policyfile extends FVO_policyfile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_policyfile extends CDTO_policyfile {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_policyfile extends FVO_policyfile {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
