import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_region {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '代码' })
  'code': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '下级' })
  'children': Array<any> = undefined;
}

export class QDTO_region extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['code', 'name'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '代码' })
  'code': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
}

export class QVO_region extends FVO_region {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_region {
  @ApiProperty({ description: '代码' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
}

export class CVO_region extends FVO_region {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_region extends CDTO_region {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_region extends FVO_region {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
