import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_resource {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '来源名称' })
  'name': string = undefined;
  @ApiProperty({ description: '二级项目来源' })
  'name_two': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}
export class QDTO_resource extends SearchBase {
  constructor() {
    const like_prop = ['name', 'name_two'];
    const props = ['name', 'name_two', 'sort'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '来源名称' })
  'name': string = undefined;
  @ApiProperty({ description: '二级项目来源' })
  'name_two': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QVO_resource extends FVO_resource {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_resource {
  @ApiProperty({ description: '来源名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '二级项目来源' })
  @Rule(RuleType['string']().empty(''))
  'name_two': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_resource extends FVO_resource {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_resource extends CDTO_resource {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_resource extends FVO_resource {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
