import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_tecAward {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '成果类别' })
  'resultype': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '完成人' })
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QDTO_tecAward extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['name', 'type', 'resulnumber', 'resultype', 'direction', 'lab_id', 'is_show', 'act_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '类别' })
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  'name': string = undefined;
  @ApiProperty({ description: '成果类别' })
  'resultype': string = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': string = undefined;
  @ApiProperty({ description: '实验室id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  'is_show': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  'act_time': string = undefined;
}

export class QVO_tecAward extends FVO_tecAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_tecAward {
  @ApiProperty({ description: '类别' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '成果编号' })
  @Rule(RuleType['string']().empty(''))
  'resulnumber': string = undefined;
  @ApiProperty({ description: '成果名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '成果类别' })
  @Rule(RuleType['string']().empty(''))
  'resultype': string = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['string']().empty(''))
  'direction': string = undefined;
  @ApiProperty({ description: '完成人' })
  @Rule(RuleType['array']().empty(''))
  'user_id': Array<any> = undefined;
  @ApiProperty({ description: '附件' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '实验室id' })
  @Rule(RuleType['string']().empty(''))
  'lab_id': string = undefined;
  @ApiProperty({ description: '是否公开' })
  @Rule(RuleType['string']().empty(''))
  'is_show': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
  @ApiProperty({ description: '填写时间段' })
  @Rule(RuleType['string']().empty(''))
  'act_time': string = undefined;
}

export class CVO_tecAward extends FVO_tecAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_tecAward extends CDTO_tecAward {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_tecAward extends FVO_tecAward {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
