import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
export class InspectCard {
  @ApiProperty({ description: '表名' })
  table: string;
  @ApiProperty({ description: '身份证号' })
  card: string;
  @ApiProperty({ description: '实验室id' })
  lab_id: string;
}

export class personTotal extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['name', 'lab_id'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  name: string;
  @ApiProperty({ description: '实验室id' })
  lab_id: string;
}
export class ExportByLab {
  @ApiProperty({ description: '表配置' })
  config: object;
  @ApiProperty({ description: '导出的实验室' })
  targets: Array<string>;
  @ApiProperty({ description: '查询条件' })
  query: object;
}

export class FilesConfig {
  root_path: string;
  project: string;
  export_dir: string;
  file_domain?: string;
}

export interface FilePath {
  fullPath: string;
  downPath: string;
}

export interface GetExportData {
  table: string; //表名
  lab_ids: Array<any>; // 实验室id集合
  query: object; //查询条件
  targetModel: any; //查询目标模型
  modelConfig: Array<any>; //目标模型参数设置
}
