import { IMiddleware, Inject, MidwayWebRouterService } from '@midwayjs/core';
import { Middleware } from '@midwayjs/decorator';
import { NextFunction, Context } from '@midwayjs/koa';
@Middleware()
export class SelfDataMiddleware implements IMiddleware<Context, NextFunction> {
  @Inject()
  webRouterService: MidwayWebRouterService;
  resolve() {
    return async (ctx: Context, next: NextFunction) => {
      const routeInfo = await this.webRouterService.getMatchedRouterInfo(ctx.path, ctx.method);
      routeInfo;
      await next();
    };
  }
  static getName(): string {
    return 'selfData';
  }
}
